      -------------------- Définition des variables --------------------
-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
local addonName = "GearHelper"
local version = GetAddOnMetadata(addonName, "Version")
local prefix = "GeARHeLPeRPReFIX"--..version -- rajouter version si on veut que notre addon ne comunique QUE avec les GH de la même version
-- ^ Pour le préfix, choisir un nom qu'on est sûr que personne d'autre ne réutilisera

local loadFrame = CreateFrame("Frame") -- Frame pour la vérification du chargement de GH
local eventHandler, allEvents = CreateFrame("Frame"), {}
-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
      ----------------- Fin de définition des variables -----------------


-- Initialise la variable sur true la première fois qu'on utilise l'addon
-- Variable par perso, permet d'avoir différents profils
local function setDefault()
	GHActivated = true
end

-- fonction qui permet d'activer / désactiver l'addon
function setActivated( valeur )
	if valeur == true then
		GHActivated = true
		print("|cFF00FF00GearHelper|r|cFF0000FF Activated|r") 
	elseif valeur == false then
		GHActivated = false
		print("|cFF00FF00GearHelper|r|cFFFF0000 Deactivated|r")
	else
		print("Erreur de changement de valeur de GHActivated (activer/désactiver l'addon)")
	end
end

-- permet de savoir si une nouvelle version est en ligne
function sendVersion()
	SendAddonMessage(prefix, version, "canal")
end
function getNewVersion(msgV, msgC)
	if msgV ~= version then
		print("Vous utilisez la version |cFFFF0000"..version.."|r de GearHelper. La version |cFF00FF00"..msgV.."|r a été trouvée chez .."..msgC)
	end
end

-------------------------------------------------------------------------------
-------------------------------------------------------------------------------

----------------------
-- Helper functions --				Pour ceux qui se demandent, oui, je dessine mieux en ASCII que je ne code
----------------------
local function getCommand( command, instruction)
	return "|cFFFF7D0A"..command.." : |r"..instruction
end

--------------------
-- Slash commands --
--------------------
local allCommands = {
	void = "|cFFFFFF00Tapez |cFF00FF00/gh|r|cFFFFFF00 ou |cFF00FF00/gh help|r|cFFFFFF00 pour voir l'aide|r",
	on = "|cFFFFFF00/gh on --> active l'addon",
	off = "|cFFFFFF00/gh off --> désactive l'addon",
}

local slashCmdFunc = {
	voidcommand = function ( msg )
		print(allCommands.void)
	end,
	on = function ( msg )
		if GHActivated == false then
			setActivated(true)
		end		
	end,
	enable = function ( msg )
		if GHActivated == false then
			setActivated(true)
		end		
	end,
	activated = function ( msg )
		if GHActivated == false then
			setActivated(true)
		end		
	end,
	off = function ( msg )
		if GHActivated == true then
			setActivated(false)
		end
	end,
	disable = function ( msg )
		if GHActivated == true then
			setActivated(false)
		end
	end,
	deactivated = function ( msg )
		if GHActivated == true then
			setActivated(false)
		end
	end,
	help = function ( msg )
		print(allCommands.on)
		print(allCommands.off)
	end,
}

-- Activation de /cmd
SLASH_GEARHELPER1 = "/gh"
SLASH_GEARHELPER2 = "/Gh"
SLASH_GEARHELPER3 = "/gH"
SLASH_GEARHELPER4 = "/GH"
SLASH_GEARHELPER5 = "/GearHelper"
SLASH_GEARHELPER6 = "/Gearhelper"
SLASH_GEARHELPER7 = "/gearhelper"
-- Fin d'activation des /cmd
-- Déclaration des /cmd
SlashCmdList["GEARHELPER"] = function ( msg )
local instruction = msg:match("%a+")
if instruction then instruction = instruction:lower() end
	if msg == "" then
		slashCmdFunc["help"](msg)
	else
		if slashCmdFunc[instruction] then
			slashCmdFunc[instruction](msg)
		else
			slashCmdFunc["voidcommand"](msg)
		end
	end
end
-- Fin déclaration des /cmd

-------------------
-- Event handler --
-------------------
function allEvents:ADDON_LOADED( name )
	if name == addonName then
		-- charge le préfix de l'addon (ou un truc du genre)
		RegisterAddonMessagePrefix(prefix) 

		-- Active l'addon par défaut lors de la première connexion après l'installation
		if type(GHActivated) == "nil" then 
			setDefault() 
		end

		-- Affiche à chaque connection l'état de l'addon
		if GHActivated == true then 
			print("|cFF00FF00GearHelper|r|cFF0000FF Activated|r") 
		else 
			print("|cFF00FF00GearHelper|r|cFFFF0000 Deactivated|r") 
		end
	end
end
function allEvents:CHAT_MSG_ADDON( message, sender, ... )
	getNewVersion(message, sender)
end
--------------------------------------------
-- xxxxx xxxxxxx --      -- xxxxx xxxxxxx --
--------------------------------------------


for event, _ in pairs(allEvents) do
	eventHandler:RegisterEvent(event)
end
eventHandler:SetScript("OnEvent", function ( self, event, ... )
	if GHActivated == true then
		allEvents[event](self, ...)
	end
end)

-------------------------------------------------------------------------------
-------------------------------------------------------------------------------
-- Déclarations des variables locales   -- A METTRE  EN HAUT LE JOUR OÙ ON L'UTILISE !!
--local SlashCmdHandler = {
--[1] = "on",
--[2] = "activated",
--[3] = "enable",                  A UTILISER !
--[4] = "off",
--[5] = "deactivated",
--[6] = "disable"
--}



--------------
-- pour chaques piece de stuff
-- faire une recherche dans l'inventaire
-- regarder s'il existe un stuff du même type
-- si oui, regarder s'il est meilleurs que celui qu'on à
-- si oui l'équiper
-- si non, le laisser dans l'inventaire



